VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmEditPars 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Par. editor"
   ClientHeight    =   4335
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   5415
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmEditPars.frx":0000
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   ScaleHeight     =   289
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   361
   WhatsThisHelp   =   -1  'True
   Begin VB.TextBox txtTime 
      Height          =   315
      Left            =   2880
      MaxLength       =   5
      TabIndex        =   3
      Top             =   1620
      Width           =   2355
   End
   Begin VB.TextBox txtMap 
      Height          =   315
      Left            =   4200
      MaxLength       =   3
      TabIndex        =   2
      Top             =   840
      Width           =   1035
   End
   Begin VB.TextBox txtEpisode 
      Height          =   315
      Left            =   2880
      MaxLength       =   3
      TabIndex        =   1
      Top             =   840
      Width           =   1035
   End
   Begin VB.CommandButton cmdAdd 
      Caption         =   "&Add"
      Height          =   375
      Left            =   2880
      TabIndex        =   4
      ToolTipText     =   "Add a new string"
      Top             =   3300
      Width           =   2355
   End
   Begin VB.CommandButton cmdRemove 
      Caption         =   "R&emove"
      Height          =   375
      Left            =   2880
      TabIndex        =   5
      ToolTipText     =   "Remove the selected string(s)"
      Top             =   3780
      Width           =   2355
   End
   Begin MSComctlLib.ListView lvwPars 
      Height          =   4335
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2655
      _ExtentX        =   4683
      _ExtentY        =   7646
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      FullRowSelect   =   -1  'True
      GridLines       =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   0
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Bitstream Vera Sans Mono"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      NumItems        =   3
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Episode"
         Object.Width           =   1799
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Map"
         Object.Width           =   952
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Text            =   "Time"
         Object.Width           =   1376
      EndProperty
   End
   Begin VB.Label lblMapTitle 
      Caption         =   "-"
      Height          =   195
      Left            =   2880
      TabIndex        =   9
      Top             =   180
      Width           =   1515
   End
   Begin VB.Label lblTime 
      Caption         =   "Time"
      Height          =   195
      Left            =   2880
      TabIndex        =   8
      Top             =   1380
      Width           =   555
   End
   Begin VB.Label lblMap 
      Caption         =   "Map"
      Height          =   195
      Left            =   4200
      TabIndex        =   7
      Top             =   600
      Width           =   495
   End
   Begin VB.Label lblEpisode 
      Caption         =   "Episode"
      Height          =   195
      Left            =   2880
      TabIndex        =   6
      Top             =   600
      Width           =   915
   End
End
Attribute VB_Name = "frmEditPars"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' -------------------------------------------------------------------------------
'
'  WhackEd3 - A Windows Doom hacking utility
'  Copyright (C) 2003-2009  Dennis Meuwissen
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'  GNU General Public License for more details.
'
'  You should have received a copy of the GNU General Public License
'  along with this program; if not, write to the Free Software
'  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
' -------------------------------------------------------------------------------
'
'   frmEditPars.frm
'   Purpose: The par time editor.
'
Option Explicit
Option Compare Binary
Option Base 0


' Add a new par time entry
Private Sub cmdAdd_Click()

    Dim newItem As ListItem


    ' Create the new item in the listview
    Set newItem = lvwPars.ListItems.Add(, , "0")
    newItem.ListSubItems.Add , , "1"
    newItem.ListSubItems.Add , , "30"
    
    ' Add the new entry to the table
    Patch.nPars = Patch.nPars + 1
    ReDim Preserve Patch.Pars(Patch.nPars - 1)
    Patch.Pars(Patch.nPars - 1).Episode = 0
    Patch.Pars(Patch.nPars - 1).Map = 1
    Patch.Pars(Patch.nPars - 1).Time = 30
    
    ' Select only the new item
    newItem.Selected = True
    lvwPars_ItemClick lvwPars.SelectedItem
    
    setMode True
    patchHasChanged
    
    txtEpisode.SetFocus

End Sub


' Remove a par time
Private Sub cmdRemove_Click()

    Dim A As Long
    Dim oldIndex As Long
    
    
    If lvwPars.SelectedItem Is Nothing Then Exit Sub
    
    ' Delete it from the control
    oldIndex = lvwPars.SelectedItem.Index
    lvwPars.ListItems.Remove lvwPars.SelectedItem.Index
    
    ' Select new item
    If lvwPars.ListItems.Count > 0 Then
        If oldIndex < lvwPars.ListItems.Count Then
            lvwPars.ListItems(oldIndex).Selected = True
        ElseIf oldIndex >= lvwPars.ListItems.Count Then
            lvwPars.ListItems(lvwPars.ListItems.Count).Selected = True
        End If
    Else
        setMode False
    End If
    
    ' Remove the item from the array
    For A = oldIndex - 1 To Patch.nPars - 2
        Patch.Pars(A) = Patch.Pars(A + 1)
    Next A
    
    ' Redimension array
    Patch.nPars = Patch.nPars - 1
    ReDim Preserve Patch.Pars(Patch.nPars)
    
    ' Update values
    UpdateVals
    updateMapCaption
    
    patchHasChanged

End Sub


' Form events
Private Sub Form_Load()
    
    appLog.Add "  Loaded " & Me.Name
    
    setMode False

End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    ' Hide the form instead
    Me.Hide
    frmMain.tlbEditors.Buttons(9).Value = tbrUnpressed
    Cancel = 1
    
End Sub


' Set new editing mode availability
Private Sub setMode(ByVal newMode As Boolean)

    txtEpisode.Enabled = newMode
    txtMap.Enabled = newMode
    txtTime.Enabled = newMode
    
    lblMapTitle.Enabled = newMode
    lblEpisode.Enabled = newMode
    lblMap.Enabled = newMode
    lblTime.Enabled = newMode

End Sub


' Update displayed values
Private Sub UpdateVals()

    If lvwPars.SelectedItem Is Nothing Then
        txtEpisode.Text = vbNullString
        txtMap.Text = vbNullString
        txtTime.Text = vbNullString
        Exit Sub
    End If
    
    ' Update values
    txtEpisode.Text = Patch.Pars(lvwPars.SelectedItem.Index - 1).Episode
    txtMap.Text = Patch.Pars(lvwPars.SelectedItem.Index - 1).Map
    txtTime.Text = Patch.Pars(lvwPars.SelectedItem.Index - 1).Time

End Sub


' Update map name caption
Private Sub updateMapCaption()

    Dim Time As String
    Dim mapName As String
    
    
    If lvwPars.SelectedItem Is Nothing Then
        lblMapTitle.Caption = "-"
        Exit Sub
    End If
    
    ' Create time and name
    Time = Trim$(Str$(Val(txtTime.Text) \ 60) & ":" & (PadString(Trim$(Str$(Val(txtTime.Text) Mod 60)), "0", 2)))
    mapName = MapString(Val(txtEpisode.Text), Val(txtMap.Text))
    
    ' Update title caption
    lblMapTitle.Caption = mapName & " (" & Time & ")"

End Sub


' Item click actives the par time
Private Sub lvwPars_ItemClick(ByVal Item As MSComctlLib.ListItem)
    
    ' Quit if nothing selected
    If lvwPars.SelectedItem Is Nothing Then
        setMode False
        Exit Sub
    End If
    
    ' Update values
    UpdateVals
    setMode True
    
End Sub


' Keypress = click
Private Sub lvwPars_KeyPress(KeyAscii As Integer)

    lvwPars_ItemClick lvwPars.SelectedItem

End Sub


' Value changers
Private Sub txtEpisode_Change()
    If lvwPars.SelectedItem Is Nothing Then Exit Sub
    lvwPars.SelectedItem.Text = txtEpisode.Text
    Patch.Pars(lvwPars.SelectedItem.Index - 1).Episode = Val(txtEpisode.Text)
    updateMapCaption
    patchHasChanged
End Sub
Private Sub txtMap_Change()
    If lvwPars.SelectedItem Is Nothing Then Exit Sub
    lvwPars.SelectedItem.ListSubItems(1).Text = txtMap.Text
    Patch.Pars(lvwPars.SelectedItem.Index - 1).Map = Val(txtMap.Text)
    updateMapCaption
    patchHasChanged
End Sub
Private Sub txtTime_Change()
    If lvwPars.SelectedItem Is Nothing Then Exit Sub
    lvwPars.SelectedItem.ListSubItems(2).Text = txtTime.Text
    Patch.Pars(lvwPars.SelectedItem.Index - 1).Time = Val(txtTime.Text)
    updateMapCaption
    patchHasChanged
End Sub


' Value select on focus
Private Sub txtEpisode_GotFocus()
    selectAll txtEpisode
End Sub
Private Sub txtMap_GotFocus()
    selectAll txtMap
End Sub
Private Sub txtTime_GotFocus()
    selectAll txtTime
End Sub


' Setup the form's data and lists
Public Sub fillStaticData()

    Dim A As Long
    
    
    lvwPars.ListItems.Clear
    For A = 0 To Patch.nPars - 1
        lvwPars.ListItems.Add , , Patch.Pars(A).Episode
        lvwPars.ListItems(A + 1).ListSubItems.Add , , Patch.Pars(A).Map
        lvwPars.ListItems(A + 1).ListSubItems.Add , , Patch.Pars(A).Time
    Next A

End Sub
