VERSION 5.00
Begin VB.Form frmPropString 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "String"
   ClientHeight    =   7335
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8355
   ControlBox      =   0   'False
   Icon            =   "frmPropString.frx":0000
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   489
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   557
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      BeginProperty Font 
         Name            =   "Segoe UI"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   180
      TabIndex        =   2
      Top             =   6780
      Width           =   2355
   End
   Begin VB.CommandButton cmdAccept 
      Caption         =   "&Accept"
      BeginProperty Font 
         Name            =   "Segoe UI"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   5820
      TabIndex        =   4
      Top             =   6780
      Width           =   2355
   End
   Begin VB.CommandButton cmdRestore 
      Caption         =   "&Restore"
      BeginProperty Font 
         Name            =   "Segoe UI"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   3000
      TabIndex        =   3
      Top             =   6780
      Width           =   2355
   End
   Begin VB.TextBox txtNewString 
      BeginProperty Font 
         Name            =   "Bitstream Vera Sans Mono"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2715
      HideSelection   =   0   'False
      Left            =   180
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Tag             =   "2"
      Top             =   3480
      Width           =   7995
   End
   Begin VB.TextBox txtOldString 
      BackColor       =   &H8000000F&
      BeginProperty Font 
         Name            =   "Bitstream Vera Sans Mono"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2715
      HideSelection   =   0   'False
      Left            =   180
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Tag             =   "2"
      Top             =   180
      Width           =   7995
   End
   Begin VB.Label lblCharsLeft 
      Caption         =   "Characters left: 100"
      BeginProperty Font 
         Name            =   "Segoe UI"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   180
      TabIndex        =   6
      Top             =   6300
      Width           =   2475
   End
   Begin VB.Label lblLength 
      Caption         =   "Length: 100"
      BeginProperty Font 
         Name            =   "Segoe UI"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   180
      TabIndex        =   5
      Top             =   3000
      Width           =   1875
   End
End
Attribute VB_Name = "frmPropString"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' -------------------------------------------------------------------------------
'
'  WhackEd3 - A Windows Doom hacking utility
'  Copyright (C) 2003-2009  Dennis Meuwissen
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'  GNU General Public License for more details.
'
'  You should have received a copy of the GNU General Public License
'  along with this program; if not, write to the Free Software
'  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
' -------------------------------------------------------------------------------
'
'   frmPropString.frm
'   Purpose: String property form.
'
Option Explicit
Option Compare Binary
Option Base 0


' Previous string in the new string textbox
Private PreviousNewString As String

' String info
Private MaxLength As Long
Private OldLength As Long
Private NewLength As Long
Public EngineString As String


' Accept changes and hide the form
Private Sub cmdAccept_Click()

    stringSuccessfull = True
    Me.Hide

End Sub


' Cancel and hide the form
Private Sub cmdCancel_Click()

    stringSuccessfull = False
    Me.Hide

End Sub


' Restore the new string textbox to the old string textbox
Private Sub cmdRestore_Click()

    txtNewString.Text = txtOldString.Text

End Sub


' Do stuff on Form_Activate
Private Sub Form_Activate()

    txtNewString.SetFocus
    PreviousNewString = txtNewString.Text
    
    ' Determine mode
    If Engine.Extended = True Then
        lblCharsLeft.Caption = "Length: " & Len(txtNewString.Text)
    Else
        lblCharsLeft.Caption = "Characters left: 0"
    End If
    
    txtNewString_Change

End Sub


' Do stuff on form load
Private Sub Form_Load()

    appLog.Add "  Loaded " & Me.Name

End Sub


' Detect changes that lengthen the string beyond its maximum size
Private Sub txtNewString_Change()

    Dim SelStart As Long
    Dim EngineLength As Long
    
       
    ' Extended
    If Engine.Extended = True Then
        lblCharsLeft.Caption = "Length: " & Len(txtNewString.Text)
        
    ' Normal
    Else
    
        NewLength = Len(UnEscaped(UnReturned(txtNewString.Text)))
    
        ' Set the old string if it got too long
        If NewLength > MaxLength Then
            SelStart = txtNewString.SelStart - 1
            txtNewString.Text = PreviousNewString
            If SelStart >= 0 Then txtNewString.SelStart = SelStart
        End If
        
        ' Remember old string
        PreviousNewString = txtNewString.Text
        
        lblCharsLeft.Caption = "Characters left: " & (MaxLength - NewLength)
        
    End If

End Sub


' Insert escape codes instead of literal characters
Private Sub txtNewString_KeyPress(KeyAscii As Integer)

    If KeyAscii = 13 Then txtNewString.SelText = "\n"
    
End Sub


' Update Old String info
Private Sub txtOldString_Change()
    
    ' Normal
    If Engine.Extended = False Then
        OldLength = Len(UnEscaped(UnReturned(txtOldString.Text)))
        MaxLength = ((Len(EngineString) \ 4) * 4) + 3
    
    ' Exntended
    Else
        OldLength = Len(txtOldString.Text)
    End If
            
    lblLength.Caption = "Length: " & OldLength
    
End Sub
