VERSION 5.00
Object = "{FE0065C0-1B7B-11CF-9D53-00AA003C9CB6}#1.1#0"; "comct232.ocx"
Begin VB.Form frmSelectSprite 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Sprites"
   ClientHeight    =   5295
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5895
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmSelectSprite.frx":0000
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   353
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   393
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin ComCtl2.UpDown udFrame 
      Height          =   315
      Left            =   2940
      TabIndex        =   2
      Top             =   4260
      Width           =   255
      _ExtentX        =   450
      _ExtentY        =   556
      _Version        =   327681
      OrigLeft        =   196
      OrigTop         =   284
      OrigRight       =   213
      OrigBottom      =   305
      Max             =   31
      Enabled         =   -1  'True
   End
   Begin VB.TextBox txtFrame 
      BeginProperty DataFormat 
         Type            =   1
         Format          =   "0"
         HaveTrueFalseNull=   0
         FirstDayOfWeek  =   0
         FirstWeekOfYear =   0
         LCID            =   1043
         SubFormatType   =   1
      EndProperty
      Height          =   315
      Left            =   2340
      TabIndex        =   1
      Text            =   "0"
      Top             =   4260
      Width           =   555
   End
   Begin VB.PictureBox picPreview 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      ForeColor       =   &H80000008&
      Height          =   3975
      Left            =   1320
      ScaleHeight     =   3945
      ScaleWidth      =   4365
      TabIndex        =   5
      Top             =   180
      Width           =   4395
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   180
      TabIndex        =   3
      Top             =   4740
      Width           =   2355
   End
   Begin VB.CommandButton cmdAccept 
      Caption         =   "&Accept"
      Default         =   -1  'True
      Height          =   375
      Left            =   3360
      TabIndex        =   4
      Top             =   4740
      Width           =   2355
   End
   Begin VB.ListBox lstSprites 
      BeginProperty Font 
         Name            =   "Bitstream Vera Sans Mono"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4395
      IntegralHeight  =   0   'False
      Left            =   180
      TabIndex        =   0
      Tag             =   "2"
      Top             =   180
      Width           =   915
   End
   Begin VB.Label lblSpriteName 
      Caption         =   "-"
      BeginProperty Font 
         Name            =   "Bitstream Vera Sans Mono"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   4800
      TabIndex        =   7
      Tag             =   "2"
      Top             =   4320
      Width           =   855
   End
   Begin VB.Label lblFrame 
      Caption         =   "Frame"
      Height          =   255
      Left            =   1320
      TabIndex        =   6
      Top             =   4320
      Width           =   915
   End
End
Attribute VB_Name = "frmSelectSprite"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' -------------------------------------------------------------------------------
'
'  WhackEd3 - A Windows Doom hacking utility
'  Copyright (C) 2003-2009  Dennis Meuwissen
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'  GNU General Public License for more details.
'
'  You should have received a copy of the GNU General Public License
'  along with this program; if not, write to the Free Software
'  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
' -------------------------------------------------------------------------------
'
'   frmSelectSprite.frm
'   Purpose: The sprite\sprite frame selection dialog.
'
Option Explicit
Option Compare Binary
Option Base 0


' Prevent recursive updates
Private disableUpdates As Boolean


' Convert between sprite frame values and text
Private Function spriteTextToValue(ByVal Text As String) As Long

    If Config.Root.Item("frameCharacter") = 0 Then
        spriteTextToValue = Val(Text)
    Else
        spriteTextToValue = Asc(UCase$(Text)) - 65
    End If

End Function

Private Function spriteValueToText(ByVal Value As Long) As String

    If Config.Root.Item("frameCharacter") = 0 Then
        spriteValueToText = Value
    Else
        spriteValueToText = Chr$(Value + 65)
    End If

End Function


' Accept changes and hide
Private Sub cmdAccept_Click()

    Dim frameValue As Long


    exchangeSprite.Num = lstSprites.listIndex
    exchangeSprite.Frame = spriteTextToValue(txtFrame.Text) Or (exchangeSprite.Frame And (2 ^ 15))

    Me.Hide

End Sub


' Decline changes and hide form
Private Sub cmdCancel_Click()

    exchangeSprite.Num = -1

    Me.Hide

End Sub


' Form events
Private Sub Form_Load()

    appLog.Add "  Loaded " & Me.name

End Sub

Private Sub Form_Activate()

    Dim frameValue As Long
    
    
    ' Select sprite
    lstSprites.listIndex = exchangeSprite.Num
    
    ' Select frame
    txtFrame.Text = spriteValueToText(exchangeSprite.Frame And Not (2 ^ 15))
   
    renderPreview

End Sub


' Fill the form with all the info
Public Sub fillStaticData()

    Dim A As Long


    lstSprites.Clear
    For A = 0 To UBound(Patch.SpriteNames())
        lstSprites.AddItem Patch.SpriteNames(A)
    Next A

    lstSprites.listIndex = 0

End Sub


' Draw the sprite preview
Private Sub renderPreview()
    
    Dim lumpName As String


    lumpName = modUtil.previewSprite(picPreview, exchangeSprite.Num, exchangeSprite.Frame And Not (2 ^ 15))
    
    If lumpName = vbNullString Then
        lblSpriteName.Caption = "-"
    Else
        lblSpriteName.Caption = lumpName
    End If
        
End Sub


' lstSprites events
Private Sub lstSprites_Click()

    If Config.Root.Item("frameCharacter") = 0 Then
        txtFrame.Text = "0"
    Else
        txtFrame.Text = "A"
    End If
    exchangeSprite.Num = lstSprites.listIndex
        
    renderPreview

End Sub

Private Sub lstSprites_DblClick()

    cmdAccept_Click

End Sub


' txtFrame events
Private Sub txtFrame_Change()

    Dim frameValue As Long
    
    
    If disableUpdates Then Exit Sub
    disableUpdates = True
    
    With exchangeSprite
        If Config.Root.Item("frameCharacter") = 0 Then
            .Frame = validateValue(txtFrame, 0, 31) Or (.Frame And 2 ^ 15)
        Else
            frameValue = Asc(UCase$(txtFrame.Text)) - 65
            If frameValue < 0 Then frameValue = 0
            If frameValue > 31 Then frameValue = 31
            
            txtFrame.Text = Chr$(frameValue + 65)
            .Frame = frameValue
        End If
    End With
    
    renderPreview
    disableUpdates = False

End Sub

Private Sub txtFrame_GotFocus()

    selectAll txtFrame

End Sub


' UpDown button manual code events
Private Sub udFrame_DownClick()

    Dim frameValue As Long
    
    
    frameValue = spriteTextToValue(txtFrame.Text)
    If frameValue <= 0 Then Exit Sub
    
    frameValue = frameValue - 1
    txtFrame.Text = spriteValueToText(frameValue)

End Sub

Private Sub udFrame_UpClick()

    Dim frameValue As Long
    
    
    frameValue = spriteTextToValue(txtFrame.Text)
    If frameValue >= 31 Then Exit Sub
    
    frameValue = frameValue + 1
    txtFrame.Text = spriteValueToText(frameValue)

End Sub
