VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmSelectState 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "State Selector"
   ClientHeight    =   7035
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8115
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   469
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   541
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdAccept 
      Caption         =   "&Accept"
      Default         =   -1  'True
      Height          =   375
      Left            =   5580
      TabIndex        =   2
      Top             =   6480
      Width           =   2355
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   180
      TabIndex        =   1
      Top             =   6480
      Width           =   2355
   End
   Begin MSComctlLib.ListView lvwSelectStates 
      Height          =   6135
      Left            =   180
      TabIndex        =   0
      Top             =   180
      Width           =   7755
      _ExtentX        =   13679
      _ExtentY        =   10821
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      FullRowSelect   =   -1  'True
      GridLines       =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   0
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Bitstream Vera Sans Mono"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      NumItems        =   10
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "#"
         Object.Width           =   1005
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Name"
         Object.Width           =   1376
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Text            =   "Spr"
         Object.Width           =   952
      EndProperty
      BeginProperty ColumnHeader(4) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   3
         Text            =   "Frm"
         Object.Width           =   952
      EndProperty
      BeginProperty ColumnHeader(5) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   4
         Text            =   "Lit"
         Object.Width           =   952
      EndProperty
      BeginProperty ColumnHeader(6) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   5
         Text            =   "Next"
         Object.Width           =   1164
      EndProperty
      BeginProperty ColumnHeader(7) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   6
         Text            =   "Dur"
         Object.Width           =   952
      EndProperty
      BeginProperty ColumnHeader(8) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   7
         Text            =   "Par1"
         Object.Width           =   1376
      EndProperty
      BeginProperty ColumnHeader(9) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   8
         Text            =   "Par2"
         Object.Width           =   1376
      EndProperty
      BeginProperty ColumnHeader(10) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   9
         Text            =   "Action"
         Object.Width           =   3069
      EndProperty
   End
End
Attribute VB_Name = "frmSelectState"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' -------------------------------------------------------------------------------
'
'  WhackEd3 - A Windows Doom hacking utility
'  Copyright (C) 2003-2009  Dennis Meuwissen
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'  GNU General Public License for more details.
'
'  You should have received a copy of the GNU General Public License
'  along with this program; if not, write to the Free Software
'  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
' -------------------------------------------------------------------------------
'
'   frmSelectState.frm
'   Purpose: State selection dialog
'
Option Explicit
Option Compare Binary
Option Base 0


' Accept selection and hide the form
Private Sub cmdAccept_Click()

    selectedState = lvwSelectStates.SelectedItem.Index - 1

    Me.Hide

End Sub


' Decline selection and hide form
Private Sub cmdCancel_Click()

    selectedState = -1

    Me.Hide

End Sub


' Form events
Private Sub Form_Load()

    appLog.Add "  Loaded " & Me.Name

End Sub

Private Sub Form_Activate()

    ' Select the default state when form is activated
    lvwSelectStates.ListItems(selectedState + 1).Selected = True
    lvwSelectStates.ListItems(selectedState + 1).EnsureVisible

End Sub


' Update state list
Public Sub updateStateList()

    Dim A As Long, B As Long
    Dim oldSelect As Long


    ' Remember selection
    If Not lvwSelectStates.SelectedItem Is Nothing Then
        oldSelect = lvwSelectStates.SelectedItem.Index
    Else
        oldSelect = -1
    End If

    ' Fill the entire list at once
    lvwSelectStates.Visible = False
    lvwSelectStates.ListItems.Clear
    For A = 0 To UBound(Patch.States())

        ' Add the items
        lvwSelectStates.ListItems.Add
        For B = 0 To 8
            lvwSelectStates.ListItems(A + 1).ListSubItems.Add
        Next B

        ' Update the item
        modUtil.UpdateStateEntry A + 1, A, lvwSelectStates

    Next A
    lvwSelectStates.Visible = True


    ' Only select old selection if any
    If oldSelect <> -1 Then
        lvwSelectStates.ListItems(oldSelect).Selected = True
        lvwSelectStates.ListItems(oldSelect).EnsureVisible
    End If

End Sub


' Doubleclicking a state = Accept button
Private Sub lvwSelectStates_DblClick()

    cmdAccept_Click

End Sub
