VERSION 5.00
Begin VB.Form frmPropSound 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Sound"
   ClientHeight    =   2295
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5175
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmPropSound.frx":0000
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   153
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   345
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdAccept 
      Caption         =   "&Accept"
      Default         =   -1  'True
      Height          =   375
      Left            =   2640
      TabIndex        =   3
      Top             =   1740
      Width           =   2355
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   180
      TabIndex        =   2
      Top             =   1740
      Width           =   2355
   End
   Begin VB.CheckBox chkSingularity 
      Caption         =   "Singular"
      Height          =   315
      Left            =   300
      TabIndex        =   1
      ToolTipText     =   "Play only one instance of this sound at the same time"
      Top             =   900
      Width           =   1275
   End
   Begin VB.HScrollBar scrlPriority 
      Height          =   315
      LargeChange     =   32
      Left            =   180
      Max             =   127
      TabIndex        =   0
      Top             =   420
      Width           =   4215
   End
   Begin VB.Label Label4 
      Caption         =   "Reference sound"
      Height          =   195
      Left            =   180
      TabIndex        =   7
      Top             =   1380
      Width           =   1575
   End
   Begin VB.Label lblRefSound 
      Caption         =   "-"
      BeginProperty Font 
         Name            =   "Bitstream Vera Sans Mono"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   1860
      TabIndex        =   6
      Tag             =   "2"
      ToolTipText     =   "A reference to another sound"
      Top             =   1380
      Width           =   795
   End
   Begin VB.Label lblPriorityN 
      Caption         =   "64"
      Height          =   195
      Left            =   4500
      TabIndex        =   5
      ToolTipText     =   "This sound's priority over other when played"
      Top             =   480
      Width           =   435
   End
   Begin VB.Label lblPriority 
      Caption         =   "Priority"
      Height          =   195
      Left            =   180
      TabIndex        =   4
      Top             =   180
      Width           =   735
   End
End
Attribute VB_Name = "frmPropSound"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' -------------------------------------------------------------------------------
'
'  WhackEd3 - A Windows Doom hacking utility
'  Copyright (C) 2003-2009  Dennis Meuwissen
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'  GNU General Public License for more details.
'
'  You should have received a copy of the GNU General Public License
'  along with this program; if not, write to the Free Software
'  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
' -------------------------------------------------------------------------------
'
'   frmPropSound.frm
'   Purpose: Sound property dialog.
'
Option Explicit
Option Compare Binary
Option Base 0


' Settings controls
Private Sub chkSingularity_Click()

    exchangeSound.Singularity = chkSingularity.Value

End Sub

Private Sub scrlPriority_Change()

    lblPriorityN.Caption = scrlPriority.Value
    exchangeSound.Priority = scrlPriority.Value

End Sub

Private Sub scrlPriority_Scroll()

    scrlPriority_Change

End Sub


' Accept changes and hide the form
Private Sub cmdAccept_Click()

    Me.Hide

End Sub


' Decline changes and hide the form
Private Sub cmdCancel_Click()

    exchangeSound.Priority = -1

    Me.Hide

End Sub


' Update control's captions
Public Sub SetupData()

    Dim soundRef As Long


    With exchangeSound
        scrlPriority.Value = .Priority
        chkSingularity = .Singularity

        ' Calculate the sound being referred to if any
        If .Reference <> 0 Then
            soundRef = (.Reference - (Engine.OffsetSounds - Engine.OffsetDataSegment)) / 36
            lblRefSound.Caption = Patch.SoundNames(soundRef)
        Else
            lblRefSound.Caption = "-"
        End If

    End With

End Sub


' Form events
Private Sub Form_Load()

    AppLog.Add "  Loaded " & Me.Name

End Sub
