VERSION 5.00
Begin VB.Form frmSelectAction 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Actions"
   ClientHeight    =   4275
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6315
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmSelectAction.frx":0000
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   285
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   421
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdAccept 
      Caption         =   "&Accept"
      Default         =   -1  'True
      Height          =   375
      Left            =   3780
      TabIndex        =   2
      Top             =   3720
      Width           =   2355
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   180
      TabIndex        =   1
      Top             =   3720
      Width           =   2355
   End
   Begin VB.ListBox lstActions 
      Height          =   3375
      Left            =   180
      TabIndex        =   0
      Top             =   180
      Width           =   1935
   End
   Begin VB.Label lblActionTitle 
      BackStyle       =   0  'Transparent
      Caption         =   "PosRefire"
      ForeColor       =   &H8000000E&
      Height          =   195
      Left            =   2340
      TabIndex        =   3
      Top             =   240
      Width           =   2655
   End
   Begin VB.Label lblDescription 
      Appearance      =   0  'Flat
      Caption         =   "-"
      Height          =   2895
      Left            =   2340
      TabIndex        =   4
      Top             =   600
      Width           =   3735
   End
   Begin VB.Shape Shape1 
      BorderStyle     =   0  'Transparent
      FillColor       =   &H8000000D&
      FillStyle       =   0  'Solid
      Height          =   315
      Left            =   2280
      Top             =   180
      Width           =   3855
   End
End
Attribute VB_Name = "frmSelectAction"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' -------------------------------------------------------------------------------
'
'  WhackEd3 - A Windows Doom hacking utility
'  Copyright (C) 2003-2009  Dennis Meuwissen
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'  GNU General Public License for more details.
'
'  You should have received a copy of the GNU General Public License
'  along with this program; if not, write to the Free Software
'  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
' -------------------------------------------------------------------------------
'
'   frmSelectAction.frm
'   Purpose: Action selector dialog.
'
Option Explicit
Option Compare Binary
Option Base 0


Public selectedAction As Long


' Accept changes and hide the form
Private Sub cmdAccept_Click()

    selectedAction = Engine.ActionInfo.Keys(lstActions.listIndex)
    Me.Hide

End Sub


' Decline changes and hide the form
Private Sub cmdCancel_Click()

    selectedAction = -1
    Me.Hide

End Sub


' Do stuff on Form_Load
Private Sub Form_Load()

    AppLog.Add "  Loaded " & Me.Name

End Sub


' Fill the form with relevant info
Public Sub fillStaticData()

    Dim A As Long
    
    
    lstActions.Clear
    
    For A = 0 To Engine.ActionInfo.Count - 1
        lstActions.AddItem Engine.CodePointerMnemonics.Item(Trim$(Str$(Engine.ActionInfo.Keys(A))))
    Next A

End Sub


' Update description
Private Sub lstActions_Click()

    lblActionTitle.Caption = Engine.CodePointerMnemonics.Item(Trim$(Str$(Engine.ActionInfo.Keys(lstActions.listIndex))))
    lblDescription.Caption = UnEscaped(Engine.ActionInfo.Items(lstActions.listIndex))

End Sub


' Accept new Action
Private Sub lstActions_DblClick()

    cmdAccept_Click

End Sub
