VERSION 5.00
Begin VB.Form frmStartup 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Select action"
   ClientHeight    =   4755
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7575
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmStartup.frx":0000
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4755
   ScaleWidth      =   7575
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdOpen 
      Caption         =   "&Open"
      Height          =   375
      Left            =   300
      TabIndex        =   1
      Top             =   840
      Width           =   2355
   End
   Begin VB.CommandButton cmdNew 
      Caption         =   "&New"
      Height          =   375
      Left            =   300
      TabIndex        =   0
      Top             =   300
      Width           =   2355
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   4920
      TabIndex        =   3
      Top             =   4080
      Width           =   2355
   End
   Begin VB.ListBox lstRecent 
      Height          =   2010
      Left            =   300
      TabIndex        =   2
      ToolTipText     =   "A list of recently opened files"
      Top             =   1860
      Width           =   6975
   End
   Begin VB.Label lblOpen 
      Caption         =   "Open an existing patch file"
      Height          =   195
      Left            =   3000
      TabIndex        =   6
      Top             =   900
      Width           =   3075
   End
   Begin VB.Label lblNew 
      Caption         =   "Create a new patch file"
      Height          =   195
      Left            =   3000
      TabIndex        =   5
      Top             =   360
      Width           =   3075
   End
   Begin VB.Label lblRecent 
      Caption         =   "Recent files"
      Height          =   195
      Left            =   300
      TabIndex        =   4
      Top             =   1560
      Width           =   2055
   End
End
Attribute VB_Name = "frmStartup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' -------------------------------------------------------------------------------
'
'  WhackEd3 - A Windows Doom hacking utility
'  Copyright (C) 2003-2009  Dennis Meuwissen
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'  GNU General Public License for more details.
'
'  You should have received a copy of the GNU General Public License
'  along with this program; if not, write to the Free Software
'  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
' -------------------------------------------------------------------------------
'
'   frmStartup.frm
'   Purpose: Startup form - holds some shortcuts to often used functions when
'            the program has just loaded,
'
Option Explicit
Option Compare Binary
Option Base 0


' Cancel button - just hide Me
Private Sub cmdCancel_Click()
    
    Me.Hide
    
End Sub


' Create a new file
Private Sub cmdNew_Click()

    Me.Hide
    
    ' Call frmMain's new file function
    frmMain.createNewFile

End Sub


' Open an existing file
Private Sub cmdOpen_Click()

    Me.Hide
    
    ' Call frmMain's open file function
    frmMain.OpenFile ""

End Sub


' Form activate event
Private Sub Form_Activate()

    Dim A As Long
    Dim Recents As Dictionary
    
    
    ' Refill the recent List
    Set Recents = modUtil.RecentFiles
    
    lstRecent.Clear
    For A = Recents.Count - 1 To 0 Step -1
        lstRecent.AddItem Recents.Items(A)
    Next A
    
    ' Update list of recent files in the main menu bar
    frmMain.UpdateRecentList

End Sub


' Form load event
Private Sub Form_Load()

    appLog.Add "  Loaded " & Me.Name

End Sub


' Doubleclicking means opening a recent file
Private Sub lstRecent_DblClick()

    Me.Hide
    
    ' Open the file
    frmMain.OpenFile lstRecent.List(lstRecent.listIndex)

End Sub
