[Tasks]
Name: desktopicon; Description: Create a desktop icon
Name: associate; Description: Associate with WhackEd3 Project files


[Files]
Source: shared\stdole2.tlb; DestDir: {sys}; OnlyBelowVersion: 0,6; Flags: restartreplace uninsneveruninstall sharedfile regtypelib
Source: shared\msvbvm60.dll; DestDir: {sys}; OnlyBelowVersion: 0,6; Flags: restartreplace uninsneveruninstall sharedfile regserver
Source: shared\msstdfmt.dll; DestDir: {sys}; OnlyBelowVersion: 0,6; Flags: restartreplace uninsneveruninstall sharedfile regserver
Source: shared\oleaut32.dll; DestDir: {sys}; OnlyBelowVersion: 0,6; Flags: restartreplace uninsneveruninstall sharedfile regserver
Source: shared\olepro32.dll; DestDir: {sys}; OnlyBelowVersion: 0,6; Flags: restartreplace uninsneveruninstall sharedfile regserver
Source: shared\asycfilt.dll; DestDir: {sys}; OnlyBelowVersion: 0,6; Flags: restartreplace uninsneveruninstall sharedfile
Source: shared\comcat.dll; DestDir: {sys}; OnlyBelowVersion: 0,6; Flags: restartreplace uninsneveruninstall sharedfile regserver
Source: shared\scrrun.dll; DestDir: {sys}; OnlyBelowVersion: 0,6; Flags: restartreplace uninsneveruninstall sharedfile regserver

Source: shared\mscomctl.ocx; DestDir: {sys}; Flags: restartreplace sharedfile regserver
Source: shared\richtx32.ocx; DestDir: {sys}; Flags: restartreplace sharedfile regserver
Source: shared\mscomct2.ocx; DestDir: {sys}; Flags: restartreplace sharedfile regserver
Source: shared\comctl32.ocx; DestDir: {sys}; Flags: restartreplace sharedfile regserver
Source: shared\comct232.ocx; DestDir: {sys}; Flags: restartreplace sharedfile regserver

Source: changelog.txt; DestDir: {app}
Source: license.txt; DestDir: {app}
Source: whacked3.exe; DestDir: {app}
Source: bass.dll; DestDir: {app}
Source: whacked3.dll; DestDir: {app}
Source: iwaddetect.cfg; DestDir: {app}

Source: config\*.*; DestDir: {app}\config; Flags: recursesubdirs
Source: tables\*.*; DestDir: {app}\tables; Flags: recursesubdirs

Source: resources\splash.gif; DestDir: {app}\resources; Flags: recursesubdirs
Source: resources\hatchet_32.ico; DestDir: {app}\resources; Flags: recursesubdirs
Source: resources\ttf-bitstream-vera-1.10\VeraMono.ttf; DestDir: {fonts}; Flags: onlyifdoesntexist uninsneveruninstall; FontInstall: Bitstream Vera Sans Mono
Source: resources\ttf-bitstream-vera-1.10\VeraMoBd.ttf; DestDir: {fonts}; Flags: onlyifdoesntexist uninsneveruninstall; FontInstall: Bitstream Vera Sans Mono Bold
Source: resources\ttf-bitstream-vera-1.10\VeraMoIt.ttf; DestDir: {fonts}; Flags: onlyifdoesntexist uninsneveruninstall; FontInstall: Bitstream Vera Sans Mono Italic
Source: resources\ttf-bitstream-vera-1.10\VeraMoBI.ttf; DestDir: {fonts}; Flags: onlyifdoesntexist uninsneveruninstall; FontInstall: Bitstream Vera Sans Mono Bold Italic


[Dirs]
Name: {app}\resources
Name: {app}\config
Name: {app}\tables


[Icons]
Name: {group}\WhackEd3; Filename: {app}\whacked3.exe; WorkingDir: {app}; IconFilename: {app}\resources\hatchet_32.ico; IconIndex: 0
Name: {group}\Changelog; Filename: {app}\changelog.txt
Name: {group}\GNU GPL License; Filename: {app}\license.txt
Name: {userdesktop}\WhackEd3; Filename: {app}\whacked3.exe; WorkingDir: {app}; IconFilename: {app}\resources\hatchet_32.ico; IconIndex: 0; Tasks: " desktopicon"
Name: {group}\{cm:UninstallProgram, WhackEd3}; Filename: {uninstallexe}


[Setup]
InternalCompressLevel=ultra
SolidCompression=true
AppName=WhackEd3
AppVerName=WhackEd3 0.9.10 beta
DefaultDirName={pf}\WhackEd3
AlwaysUsePersonalGroup=false
ShowLanguageDialog=no
AppVersion=0.9.10 beta
UninstallDisplayIcon={app}\whacked3.exe
UninstallDisplayName=WhackEd3
AppendDefaultGroupName=true
DefaultGroupName=WhackEd3
Compression=lzma/ultra
OutputDir=.
SourceDir=.
OutputBaseFilename=whacked3_setup_0.9.10_beta
AllowNoIcons=true
PrivilegesRequired=admin
ChangesAssociations=true
InfoBeforeFile=
LicenseFile=license.txt
FlatComponentsList=true
UninstallLogMode=overwrite
LanguageDetectionMethod=none
WizardImageStretch=false


[Run]
Filename: {app}\whacked3.exe; WorkingDir: {app}; Description: Run WhackEd3; Flags: nowait postinstall unchecked hidewizard skipifsilent


[UninstallDelete]
Name: {app}\resources; Type: filesandordirs
Name: {app}\tables; Type: filesandordirs
Name: {app}\config; Type: filesandordirs
Name: {app}\*.*; Type: files
Name: {userappdata}\WhackEd3; Type: filesandordirs


[Registry]
Root: HKCR; SubKey: .deh; ValueType: string; ValueData: WhackEd3; Flags: uninsdeletekey; Tasks: associate
Root: HKCR; SubKey: .bex; ValueType: string; ValueData: WhackEd3; Flags: uninsdeletekey; Tasks: associate
Root: HKCR; SubKey: WhackEd3; ValueType: string; ValueData: WhackEd3 dehacked patch file; Flags: uninsdeletekey; Tasks: associate
Root: HKCR; SubKey: WhackEd3\Shell\Open\Command; ValueType: string; ValueData: """{app}\whacked3.exe"" -load ""%1"""; Flags: uninsdeletevalue; Tasks: associate
Root: HKCR; Subkey: WhackEd3\DefaultIcon; ValueType: string; ValueData: {app}\resources\hatchet_32.ico,0; Flags: uninsdeletevalue; Tasks: associate


